[leetcode]452. Minimum Number of Arrows to Burst Balloons

题目链接:https://leetcode.com/problems/minimum-number-of-arrows-to-burst-balloons/

There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it's horizontal, y-coordinates don't matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.

An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.

Example:

Input:
[[10,16], [2,8], [1,6], [7,12]]

Output:
2

Explanation:
One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).

解题思路:贪心算法。先对数组进行排序,如果pair中第一个值一样大,则比较第二个值,值大的排在后面,否则pair中第一个值大的排在后面。初始化count=0;先取第一个pair的第二个值作为边界,随后从前到后遍历数组。如果当前的pair中的第一个值比边界大,更新边界值为当前pair中的第二个值,count++。如果当前的pair中的第一值比边界小,边界更新为当前pair中第二个值和边界这两个数的最小值。最后的return为count++;

class Solution{
public:
    int findMinArrowShots(vector>& points)
    {
        if(points.size()<2)
            return points.size();
        auto cmp=[](paira,pairb)
        {
            if(a.first==b.first)
                return a.secondboundary)
            {
                count++;
                boundary=points[i].second;
            }
            else
            {
                boundary=points[i].second



你可能感兴趣的:(leetcode,贪心)